/***************************************************************************
 * Copyright 2014 Kieker Project (http://kieker-monitoring.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 ***************************************************************************/
package teetime.variant.explicitScheduling.stage.throughput;

/**
 * @author Christian Wulf
 * 
 * @since 1.10
 */
public class ThroughputAnalysisResult {

	private final long durationInNs;
	private final int numObjectsPassed;

	/**
	 * @since 1.10
	 */
	public ThroughputAnalysisResult(final long durationInNs, final int numObjectsPassed) {
		this.durationInNs = durationInNs;
		this.numObjectsPassed = numObjectsPassed;
	}

	public long getDurationInNs() {
		return durationInNs;
	}

	public int getNumObjectsPassed() {
		return numObjectsPassed;
	}

}
